```python
#changement de dossier
import os
os.chdir("D:/_Travaux/university/Cours_Universite/Supports_de_cours/DataAnalysis/Stat/Supports/Analyse_Factorielle/Calculs")
```


```python
#chargement des données - index_col = 0 pour indiquer que la colonne n°0 est un label
import pandas
D = pandas.read_excel("Data_Methodes_Factorielles.xlsx",sheet_name="ACM_CANINES",index_col=0)

#affichage des caractéristiques
print(D.info())

#récupération des variables actives
DActives = D[['Taille','Velocite','Affection']]
print(DActives)

#récupération des infos - nombre de variables
p = DActives.shape[1]

#nombre d'observations
n = DActives.shape[0]
```

    <class 'pandas.core.frame.DataFrame'>
    Index: 8 entries, Beauceron to Labrador
    Data columns (total 5 columns):
     #   Column     Non-Null Count  Dtype  
    ---  ------     --------------  -----  
     0   Taille     8 non-null      object 
     1   Velocite   8 non-null      object 
     2   Affection  8 non-null      object 
     3   Cote       8 non-null      float64
     4   Fonction   8 non-null      object 
    dtypes: float64(1), object(4)
    memory usage: 384.0+ bytes
    None
                   Taille Velocite Affection
    Chien                                   
    Beauceron    Taille++  Veloc++    Affec+
    Basset         Taill-    Velo-     Affe-
    Berger All   Taille++  Veloc++    Affec+
    Boxer         Taille+   Veloc+    Affec+
    Bull-Dog       Taill-    Velo-    Affec+
    Bull-Mastif  Taille++    Velo-     Affe-
    Caniche        Taill-   Veloc+    Affec+
    Labrador      Taille+   Veloc+    Affec+
    


```python
#codage en 0/1
X = pandas.get_dummies(DActives,prefix='',prefix_sep='')
print(X)
```

                 Taill-  Taille+  Taille++  Velo-  Veloc+  Veloc++  Affe-  Affec+
    Chien                                                                        
    Beauceron         0        0         1      0       0        1      0       1
    Basset            1        0         0      1       0        0      1       0
    Berger All        0        0         1      0       0        1      0       1
    Boxer             0        1         0      0       1        0      0       1
    Bull-Dog          1        0         0      1       0        0      0       1
    Bull-Mastif       0        0         1      1       0        0      1       0
    Caniche           1        0         0      0       1        0      0       1
    Labrador          0        1         0      0       1        0      0       1
    


```python
#librairie numpy
import numpy

#profil individu moyen
ind_moy = numpy.sum(X.values,axis=0)/(n*p)
print(ind_moy)
```

    [0.125      0.08333333 0.125      0.125      0.125      0.08333333
     0.08333333 0.25      ]
    


```python
#distance du KHI-2 entre beauceron (n°0) et basset (n°1)
print(numpy.sum(1/ind_moy*(X.values[0,:]/p-X.values[1,:]/p)**2))

#idem entre basset(n°1) et caniche(n°6)
print(numpy.sum(1/ind_moy*(X.values[1,:]/p-X.values[6,:]/p)**2))
```

    5.777777777777777
    3.5555555555555554
    


```python
#distance à l'origine basset (n°1)
print(numpy.sum(1/ind_moy*(X.values[1,:]/p-ind_moy)**2))

#distance à l'origine caniche (n°6)
print(numpy.sum(1/ind_moy*(X.values[6,:]/p-ind_moy)**2))
```

    2.1111111111111107
    1.2222222222222219
    


```python
#distance à l'origine des individus (obs.)
disto_ind = numpy.apply_along_axis(arr=X.values,axis=1,func1d=lambda x:numpy.sum(1/ind_moy*(x/p-ind_moy)**2))

#poids des obs.
poids_ind = numpy.ones(X.shape[0])/n

#inertie
inertie_ind = poids_ind*disto_ind

#afffichage
print(pandas.DataFrame(numpy.transpose([poids_ind,disto_ind,inertie_ind]),index=D.index))
```

                     0         1         2
    Chien                                 
    Beauceron    0.125  1.666667  0.208333
    Basset       0.125  2.111111  0.263889
    Berger All   0.125  1.666667  0.208333
    Boxer        0.125  1.666667  0.208333
    Bull-Dog     0.125  1.222222  0.152778
    Bull-Mastif  0.125  2.111111  0.263889
    Caniche      0.125  1.222222  0.152778
    Labrador     0.125  1.666667  0.208333
    


```python
#inerrie totale
inertie_tot_ind = numpy.sum(inertie_ind)
print(inertie_tot_ind)
```

    1.6666666666666665
    


```python
#analyse avec fanalysis
from fanalysis.mca import MCA

#instanciation
acm = MCA(row_labels=DActives.index,var_labels=DActives.columns)
acm.fit(DActives.values)

#propriétés
print(dir(acm))

#valeurs propres
print(acm.eig_[0])
```

    ['__class__', '__delattr__', '__dict__', '__dir__', '__doc__', '__eq__', '__format__', '__ge__', '__getattribute__', '__getstate__', '__gt__', '__hash__', '__init__', '__init_subclass__', '__le__', '__lt__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__setstate__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_binarization', '_compute_stats', '_compute_svd', '_get_param_names', '_get_tags', '_more_tags', 'c_', 'col_contrib_', 'col_coord_', 'col_cos2_', 'col_labels', 'col_labels_', 'col_labels_short_', 'col_labels_short_temp_', 'col_labels_temp_', 'col_topandas', 'eig_', 'fit', 'fit_transform', 'get_params', 'mapping', 'mapping_col', 'mapping_row', 'model_', 'n_', 'n_categories_', 'n_components', 'n_components_', 'n_vars_', 'plot_col_contrib', 'plot_col_cos2', 'plot_eigenvalues', 'plot_row_contrib', 'plot_row_cos2', 'prefixes_', 'r_', 'row_contrib_', 'row_coord_', 'row_cos2_', 'row_labels', 'row_labels_', 'row_topandas', 'set_params', 'stats', 'transform', 'var_labels']
    [0.70803126 0.59148936 0.26199182 0.06974652 0.03540771]
    


```python
#représentation dans le plan
acm.mapping(num_x_axis=1,num_y_axis=2)
```


![png](output_9_0.png)



```python
#coordonnées sur le 1er facteur
print(pandas.DataFrame(acm.row_coord_[:,0],index=DActives.index))
```

                            0
    Chien                    
    Beauceron    4.924471e-15
    Basset       1.150779e+00
    Berger All   4.763557e-15
    Boxer       -1.150779e+00
    Bull-Dog     4.284137e-01
    Bull-Mastif  1.150779e+00
    Caniche     -4.284137e-01
    Labrador    -1.150779e+00
    


```python
#inertie du 1er facteur
lambda_1_ind = numpy.mean(acm.row_coord_[:,0]**2)
print(lambda_1_ind)
```

    0.7080312581410022
    


```python
#part d'inertie
print(lambda_1_ind/inertie_tot_ind)
```

    0.42481875488460136
    


```python
#somme en colonne
somme_col = numpy.sum(X.values,axis=0)
print(somme_col)
```

    [3 2 3 3 3 2 2 6]
    


```python
#distance entre taille- (2) et velocite- (5)
print(numpy.sum(n*((X.values[:,2]/somme_col[2]-X.values[:,5]/somme_col[5])**2)))

#distance entre taille- (2) et velocite+ (3)
print(numpy.sum(n*((X.values[:,2]/somme_col[2]-X.values[:,3]/somme_col[3])**2)))
```

    1.3333333333333335
    3.5555555555555554
    


```python
#profil moyen des variables-modalités
moda_moy = numpy.ones(X.shape[0])/n

#distance à l'origine taille-
print(numpy.sum(n*((X.values[:,0]/somme_col[0]-moda_moy)**2)))

#distance à l'origine taille+
print(numpy.sum(n*((X.values[:,1]/somme_col[1]-moda_moy)**2)))
```

    1.6666666666666665
    3.0
    


```python
#poids des variables_modalités (points modalités)
poids_moda = somme_col/(n*p)

#distance à l'origine des points modalités
disto_moda = numpy.apply_along_axis(arr=X.values/somme_col,axis=0,func1d=lambda x:numpy.sum(n*(x-moda_moy)**2))

#inertie
inertie_moda = poids_moda * disto_moda

#affichage
print(pandas.DataFrame(numpy.transpose([poids_moda,disto_moda,inertie_moda]),index=X.columns,columns=['Poids','Disto','Inertie']))
```

                 Poids     Disto   Inertie
    Taill-    0.125000  1.666667  0.208333
    Taille+   0.083333  3.000000  0.250000
    Taille++  0.125000  1.666667  0.208333
    Velo-     0.125000  1.666667  0.208333
    Veloc+    0.125000  1.666667  0.208333
    Veloc++   0.083333  3.000000  0.250000
    Affe-     0.083333  3.000000  0.250000
    Affec+    0.250000  0.333333  0.083333
    


```python
#inertie totale des points-modalités
inertie_tot_moda = numpy.sum(inertie_moda)
print(inertie_tot_moda)
```

    1.6666666666666665
    


```python
#autre expression de la distance à l'origine
print(n/somme_col-1)
```

    [1.66666667 3.         1.66666667 1.66666667 1.66666667 3.
     3.         0.33333333]
    


```python
#coordonées des modalités sur le 1er facteur
print(pandas.DataFrame(acm.col_coord_[:,0],index=X.columns))
```

                         0
    Taill-    4.558738e-01
    Taille+  -1.367621e+00
    Taille++  4.558738e-01
    Velo-     1.081461e+00
    Veloc+   -1.081461e+00
    Veloc++   7.058942e-15
    Affe-     1.367621e+00
    Affec+   -4.558738e-01
    


```python
#inertie du 1er facteur
lambda_1_moda = numpy.sum(poids_moda*acm.col_coord_[:,0]**2)
print(lambda_1_moda)
```

    0.7080312581410024
    


```python
#moyenne des modalités de Taille
print(numpy.mean(poids_moda[:3]*acm.col_coord_[:3,0]))

#moyenne des modalités de Velocite
print(numpy.mean(poids_moda[3:6]*acm.col_coord_[3:6,0]))

#moyenne des modalités de Affec
print(numpy.mean(poids_moda[6:]*acm.col_coord_[6:,0]))
```

    1.3877787807814457e-17
    -1.6711016658649122e-17
    -1.3877787807814457e-17
    


```python
#rapp.correl. des Taille
rc_Taille = numpy.sum(somme_col[:3]/n*acm.col_coord_[:3,0]**2)
print(rc_Taille)

#rapp.correl. des Velocite
rc_Velocite = numpy.sum(somme_col[3:6]/n*acm.col_coord_[3:6,0]**2)
print(rc_Velocite)

#rapp.correl. des Affec
rc_Affection = numpy.sum(somme_col[6:]/n*acm.col_coord_[6:,0]**2)
print(rc_Affection)
```

    0.6234627599261655
    0.8771682545706797
    0.6234627599261622
    


```python
#moyenne des rapports de corrélation
print(1/p*numpy.sum(numpy.array([rc_Taille,rc_Velocite,rc_Affection])))
```

    0.7080312581410025
    


```python
#** ACM via l'AFC sur le tableau des indicatrices **
from fanalysis.ca import CA
afc_1 = CA(row_labels=X.index,col_labels=X.columns)
afc_1.fit(X.values)

#valeurs propres
print(pandas.DataFrame(numpy.transpose(afc_1.eig_),index=range(1,8),columns=['Val.P','%','Cumsum(%)']))
```

              Val.P             %   Cumsum(%)
    1  7.080313e-01  4.248188e+01   42.481875
    2  5.914894e-01  3.548936e+01   77.971237
    3  2.619918e-01  1.571951e+01   93.690746
    4  6.974652e-02  4.184791e+00   97.875538
    5  3.540771e-02  2.124462e+00  100.000000
    6  4.326339e-33  2.595803e-31  100.000000
    7  3.843959e-34  2.306375e-32  100.000000
    


```python
#coordonnées fact. des obs. (1er plan)
print(pandas.DataFrame(afc_1.row_coord_[:,:2],index=X.index,columns=['Fact.1','Fact.2']))
```

                       Fact.1    Fact.2
    Chien                              
    Beauceron    4.924471e-15 -1.279924
    Basset       1.150779e+00  0.799057
    Berger All   4.763557e-15 -1.279924
    Boxer       -1.150779e+00  0.385124
    Bull-Dog     4.284137e-01  0.509675
    Bull-Mastif  1.150779e+00 -0.028809
    Caniche     -4.284137e-01  0.509675
    Labrador    -1.150779e+00  0.385124
    


```python
#coordonnées fact. des modalités. (1er plan)
print(pandas.DataFrame(afc_1.col_coord_[:,:2],index=X.columns,columns=['Fact.1','Fact.2']))
```

                    Fact.1    Fact.2
    Taill-    4.558738e-01  0.788128
    Taille+  -1.367621e+00  0.500758
    Taille++  4.558738e-01 -1.121966
    Velo-     1.081461e+00  0.554740
    Veloc+   -1.081461e+00  0.554740
    Veloc++   7.058942e-15 -1.664220
    Affe-     1.367621e+00  0.500758
    Affec+   -4.558738e-01 -0.166919
    


```python
#tableau de BURT
burt = numpy.dot(numpy.transpose(X.values),X.values)
print(burt)
```

    [[3 0 0 2 1 0 1 2]
     [0 2 0 0 2 0 0 2]
     [0 0 3 1 0 2 1 2]
     [2 0 1 3 0 0 2 1]
     [1 2 0 0 3 0 0 3]
     [0 0 2 0 0 2 0 2]
     [1 0 1 2 0 0 2 0]
     [2 2 2 1 3 2 0 6]]
    


```python
#AFC sur le tableau de Burt
afc_2 = CA(row_labels=X.columns,col_labels=X.columns)
afc_2.fit(burt)

#valeurs propres corrigées
print(numpy.sqrt(afc_2.eig_[0]))
```

    [7.08031258e-01 5.91489364e-01 2.61991819e-01 6.97465196e-02
     3.54077063e-02 4.08887366e-17 2.21873573e-17]
    


```python
#coordonnées factorielles des points-modalités
temp = afc_2.col_coord_[:,:2]/numpy.sqrt(numpy.sqrt(afc_2.eig_[0][:2])) 
print(pandas.DataFrame(temp,index=X.columns,columns=['Fact.1','Fact.2']))
```

                    Fact.1    Fact.2
    Taill-   -4.558738e-01  0.788128
    Taille+   1.367621e+00  0.500758
    Taille++ -4.558738e-01 -1.121966
    Velo-    -1.081461e+00  0.554740
    Veloc+    1.081461e+00  0.554740
    Veloc++   2.012812e-15 -1.664220
    Affe-    -1.367621e+00  0.500758
    Affec+    4.558738e-01 -0.166919
    


```python
#tableau des profils lignes
profil = numpy.apply_along_axis(arr=X.values,axis=1,func1d=lambda x:x/numpy.sum(x))
print(pandas.DataFrame(profil,index=X.index,columns=X.columns))
```

                   Taill-   Taille+  Taille++     Velo-    Veloc+   Veloc++  \
    Chien                                                                     
    Beauceron    0.000000  0.000000  0.333333  0.000000  0.000000  0.333333   
    Basset       0.333333  0.000000  0.000000  0.333333  0.000000  0.000000   
    Berger All   0.000000  0.000000  0.333333  0.000000  0.000000  0.333333   
    Boxer        0.000000  0.333333  0.000000  0.000000  0.333333  0.000000   
    Bull-Dog     0.333333  0.000000  0.000000  0.333333  0.000000  0.000000   
    Bull-Mastif  0.000000  0.000000  0.333333  0.333333  0.000000  0.000000   
    Caniche      0.333333  0.000000  0.000000  0.000000  0.333333  0.000000   
    Labrador     0.000000  0.333333  0.000000  0.000000  0.333333  0.000000   
    
                    Affe-    Affec+  
    Chien                            
    Beauceron    0.000000  0.333333  
    Basset       0.333333  0.000000  
    Berger All   0.000000  0.333333  
    Boxer        0.000000  0.333333  
    Bull-Dog     0.000000  0.333333  
    Bull-Mastif  0.333333  0.000000  
    Caniche      0.000000  0.333333  
    Labrador     0.000000  0.333333  
    


```python
#réduire les profils
profil = profil/numpy.std(profil,axis=0,ddof=0)
print(profil)
```

    [[0.         0.         2.06559112 0.         0.         2.30940108
      0.         2.30940108]
     [2.06559112 0.         0.         2.06559112 0.         0.
      2.30940108 0.        ]
     [0.         0.         2.06559112 0.         0.         2.30940108
      0.         2.30940108]
     [0.         2.30940108 0.         0.         2.06559112 0.
      0.         2.30940108]
     [2.06559112 0.         0.         2.06559112 0.         0.
      0.         2.30940108]
     [0.         0.         2.06559112 2.06559112 0.         0.
      2.30940108 0.        ]
     [2.06559112 0.         0.         0.         2.06559112 0.
      0.         2.30940108]
     [0.         2.30940108 0.         0.         2.06559112 0.
      0.         2.30940108]]
    


```python
#pondération des modalités
pond_moda = (n-somme_col)/(n*p)
print(pond_moda)
```

    [0.20833333 0.25       0.20833333 0.20833333 0.20833333 0.25
     0.25       0.08333333]
    


```python
#appliquer la pondération aux profils
profil = profil*numpy.sqrt(pond_moda)
print(profil)
```

    [[0.         0.         0.94280904 0.         0.         1.15470054
      0.         0.66666667]
     [0.94280904 0.         0.         0.94280904 0.         0.
      1.15470054 0.        ]
     [0.         0.         0.94280904 0.         0.         1.15470054
      0.         0.66666667]
     [0.         1.15470054 0.         0.         0.94280904 0.
      0.         0.66666667]
     [0.94280904 0.         0.         0.94280904 0.         0.
      0.         0.66666667]
     [0.         0.         0.94280904 0.94280904 0.         0.
      1.15470054 0.        ]
     [0.94280904 0.         0.         0.         0.94280904 0.
      0.         0.66666667]
     [0.         1.15470054 0.         0.         0.94280904 0.
      0.         0.66666667]]
    


```python
#lancer une ACP
from fanalysis.pca import PCA
acp = PCA(std_unit=False,row_labels=X.index,col_labels=X.columns)
acp.fit(profil)

#valeurs propres
print(acp.eig_[0])
```

    [7.08031258e-01 5.91489364e-01 2.61991819e-01 6.97465196e-02
     3.54077063e-02 4.69842982e-33 4.02307068e-34 4.04188030e-35]
    


```python
#coordonnées fact. des observations (1er plan)
print(pandas.DataFrame(acp.row_coord_[:,:2],index=X.index,columns=['Fact.1','Fact.2']))
```

                       Fact.1    Fact.2
    Chien                              
    Beauceron   -1.021387e-15 -1.279924
    Basset       1.150779e+00  0.799057
    Berger All  -1.100184e-15 -1.279924
    Boxer       -1.150779e+00  0.385124
    Bull-Dog     4.284137e-01  0.509675
    Bull-Mastif  1.150779e+00 -0.028809
    Caniche     -4.284137e-01  0.509675
    Labrador    -1.150779e+00  0.385124
    
