```python
#changement de dossier
import os
os.chdir("D:/_Travaux/university/Cours_Universite/Supports_de_cours/DataAnalysis/Stat/Supports/Analyse_Factorielle/Calculs")
```


```python
#chargement des données - index_col = 0 pour indiquer que la colonne n°0 est un label
import pandas
D = pandas.read_excel("Data_Methodes_Factorielles.xlsx",sheet_name="DATA_ACP_ACTIF",index_col=0)

#affichage des caractéristiques
print(D.info())

#nombre de variables
p = D.shape[1]

#nombre d'observations
n = D.shape[0]

#matrice des X
X = D.values
```

    <class 'pandas.core.frame.DataFrame'>
    Index: 18 entries, Alfasud TI to Lada 1300
    Data columns (total 6 columns):
     #   Column  Non-Null Count  Dtype
    ---  ------  --------------  -----
     0   CYL     18 non-null     int64
     1   PUISS   18 non-null     int64
     2   LONG    18 non-null     int64
     3   LARG    18 non-null     int64
     4   POIDS   18 non-null     int64
     5   VMAX    18 non-null     int64
    dtypes: int64(6)
    memory usage: 1008.0+ bytes
    None
    


```python
#librairie numpy
import numpy

#matrice des corrélations
R = numpy.corrcoef(X,rowvar=False)
print(R)
```

    [[1.         0.79662771 0.70146192 0.62975716 0.78895203 0.66493402]
     [0.79662771 1.         0.64136235 0.52083197 0.765293   0.84437948]
     [0.70146192 0.64136235 1.         0.84926635 0.86809028 0.47592847]
     [0.62975716 0.52083197 0.84926635 1.         0.71687392 0.47294527]
     [0.78895203 0.765293   0.86809028 0.71687392 1.         0.4775956 ]
     [0.66493402 0.84437948 0.47592847 0.47294527 0.4775956  1.        ]]
    


```python
#librairie graphique
import seaborn as sns

#heatmap pour identifier visuellement les corrélations fortes
sns.heatmap(R,xticklabels=D.columns,yticklabels=D.columns,vmin=-1,vmax=+1,center=0,cmap="RdBu",linewidths=0.5)
```




    <matplotlib.axes._subplots.AxesSubplot at 0x2de138fc048>




![png](output_3_1.png)



```python
#inversion de la matrice
V = numpy.linalg.inv(R)
print(V)
```

    [[ 3.77201352 -0.69347038  0.31247993 -0.43395472 -1.96161216 -0.92921187]
     [-0.69347038 11.1188198   0.74480091  2.28233732 -6.86128033 -7.08436656]
     [ 0.31247993  0.74480091  7.20419514 -3.19842205 -4.48616669 -0.61010269]
     [-0.43395472  2.28233732 -3.19842205  4.19760475 -0.82030424 -1.70985103]
     [-1.96161216 -6.86128033 -4.48616669 -0.82030424  9.95728271  4.86536606]
     [-0.92921187 -7.08436656 -0.61010269 -1.70985103  4.86536606  6.37511213]]
    


```python
#matrice des corrélations partielles
RHO = numpy.zeros(shape=(p,p))

#double boucle
for l in range(p):
    for j in range(p):
        RHO[l,j] = -V[l,j]/numpy.sqrt(V[l,l]*V[j,j])
        
print(RHO)
```

    [[-1.          0.10708089 -0.05994359  0.10905787  0.32007821  0.18948909]
     [ 0.10708089 -1.         -0.08321816 -0.33407941  0.65208679  0.84144893]
     [-0.05994359 -0.08321816 -1.          0.58162393  0.52967839  0.09002566]
     [ 0.10905787 -0.33407941  0.58162393 -1.          0.1268831   0.33053206]
     [ 0.32007821  0.65208679  0.52967839  0.1268831  -1.         -0.61066241]
     [ 0.18948909  0.84144893  0.09002566  0.33053206 -0.61066241 -1.        ]]
    


```python
#heatmap pour identifier visuellement les corrélations partielles fortes
sns.heatmap(RHO,xticklabels=D.columns,yticklabels=D.columns,vmin=-1,vmax=+1,center=0,cmap="RdBu",linewidths=0.5)
```




    <matplotlib.axes._subplots.AxesSubplot at 0x2de11f37c08>




![png](output_6_1.png)



```python
#indice KMO global
KMO = (numpy.sum(R**2)-p)/((numpy.sum(R**2)-p) + (numpy.sum(RHO**2)-p))
print(KMO)
```

    0.7400088239713861
    


```python
#indice KMO par variable
KMO_var = numpy.zeros(shape=(p,))

#boucle sur les variables
for j in range(p):
    KMO_var[j] = (numpy.sum(R[:,j]**2)-1)/((numpy.sum(R[:,j]**2)-1)+(numpy.sum(RHO[:,j]**2)-1))
    
#affichage
print(pandas.DataFrame(KMO_var,index=D.columns))
```

                  0
    CYL    0.939956
    PUISS  0.674346
    LONG   0.803384
    LARG   0.783650
    POIDS  0.693091
    VMAX   0.597664
    


```python
#indice KMO par variables
KMO_j = (numpy.sum(R**2,axis=0)-1)/((numpy.sum(R**2,axis=0)-1)+(numpy.sum(RHO**2,axis=0)-1))

#affichage
print(pandas.DataFrame(KMO_j,index=D.columns))
```

                  0
    CYL    0.939956
    PUISS  0.674346
    LONG   0.803384
    LARG   0.783650
    POIDS  0.693091
    VMAX   0.597664
    
