```python
#changement de dossier
import os
os.chdir("D:/_Travaux/university/Cours_Universite/Supports_de_cours/DataAnalysis/Stat/Supports/Analyse_Factorielle/Calculs")
```


```python
#chargement - index_col = 0 pour indiquer que la colonne n°0 est un label
import pandas
D = pandas.read_excel("Data_Methodes_Factorielles.xlsx",sheet_name="AFC_ETUDES",index_col=0)

#affichage des données
print(D)

#nombre de modalités ligne
K = D.shape[0]

#nombre de modalités colonnes
L = D.shape[1]

#numpy
import numpy

#effectif total
n = numpy.sum(D.values)
print(n)

#nombre max. de facteur
Hmax = numpy.min([K-1,L-1])
print(Hmax)
```

                    Droit  Sciences  Medecine  IUT
    CSP_vs_Filiere                                
    ExpAgri            80        99        65   58
    Patron            168       137       208   62
    CadreSup          470       400       876   79
    Employe           145       133       135   54
    Ouvrier           166       193       127  129
    3784
    3
    


```python
#importation de la librairie
from fanalysis.ca import CA

#lancer les calculs
afc = CA(row_labels=D.index,col_labels=D.columns)
afc.fit(D.values)
```




    CA(col_labels=Index(['Droit', 'Sciences', 'Medecine', 'IUT'], dtype='object'),
       n_components=None,
       row_labels=Index(['ExpAgri', 'Patron', 'CadreSup', 'Employe', 'Ouvrier'], dtype='object', name='CSP_vs_Filiere'),
       stats=True)




```python
#propriétés de l'objet
print(dir(afc))
```

    ['__class__', '__delattr__', '__dict__', '__dir__', '__doc__', '__eq__', '__format__', '__ge__', '__getattribute__', '__getstate__', '__gt__', '__hash__', '__init__', '__init_subclass__', '__le__', '__lt__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__setstate__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_compute_stats', '_compute_svd', '_get_param_names', '_get_tags', '_more_tags', 'c_', 'col_contrib_', 'col_coord_', 'col_cos2_', 'col_labels', 'col_labels_', 'col_labels_short_', 'col_topandas', 'eig_', 'fit', 'fit_transform', 'get_params', 'mapping', 'mapping_col', 'mapping_row', 'model_', 'n_', 'n_components', 'n_components_', 'plot_col_contrib', 'plot_col_cos2', 'plot_eigenvalues', 'plot_row_contrib', 'plot_row_cos2', 'r_', 'row_contrib_', 'row_coord_', 'row_cos2_', 'row_labels', 'row_labels_', 'row_topandas', 'set_params', 'stats', 'transform']
    


```python
#affichage des valeurs propres
print(afc.eig_)
```

    [[8.23936026e-02 1.70344867e-03 5.39807038e-04]
     [9.73495522e+01 2.01265584e+00 6.37791913e-01]
     [9.73495522e+01 9.93622081e+01 1.00000000e+02]]
    


```python
#seuil -- moyenne des valeurs propres
meanValPropre = numpy.mean(afc.eig_[0])
print(meanValPropre)

#ou seuil sur les pourcentages
print(1/Hmax)
```

    0.028212286095157187
    0.3333333333333333
    


```python
#affichage graphique des v.p.
afc.plot_eigenvalues()
```


![png](output_6_0.png)



```python
#informations sur les modalités lignes
print(afc.row_topandas())
```

                    row_coord_dim1  row_coord_dim2  row_coord_dim3  \
    CSP_vs_Filiere                                                   
    ExpAgri               0.410115       -0.026253        0.038284   
    Patron                0.020151        0.026585       -0.046881   
    CadreSup             -0.262717       -0.015596        0.006199   
    Employe               0.142090        0.097326        0.021242   
    Ouvrier               0.451481       -0.039588       -0.009493   
    
                    row_contrib_dim1  row_contrib_dim2  row_contrib_dim3  \
    CSP_vs_Filiere                                                         
    ExpAgri                16.292006          3.229165         21.669399   
    Patron                  0.074887          6.304816         61.867745   
    CadreSup               40.401242          6.886489          3.433167   
    Employe                 3.024136         68.626434         10.316292   
    Ouvrier                40.207729         14.953096          2.713396   
    
                    row_cos2_dim1  row_cos2_dim2  row_cos2_dim3  
    CSP_vs_Filiere                                               
    ExpAgri              0.987350       0.004046       0.008604  
    Patron               0.122652       0.213489       0.663859  
    CadreSup             0.995936       0.003510       0.000554  
    Employe              0.670459       0.314556       0.014984  
    Ouvrier              0.991935       0.007627       0.000439  
    


```python
#profil marginal des modalités lignes
profMargLig = numpy.sum(D.values,axis=1)/n
print(profMargLig)
```

    [0.07980973 0.1519556  0.48229387 0.12341438 0.16252643]
    


```python
#contributions
contribLig = (numpy.reshape(profMargLig,(5,1))*afc.row_coord_**2)/afc.eig_[0]*100
print(contribLig)
```

    [[16.2920062   3.22916478 21.66939863]
     [ 0.07488716  6.30481646 61.86774549]
     [40.40124242  6.88648879  3.43316701]
     [ 3.02413561 68.62643393 10.31629239]
     [40.20772861 14.95309604  2.71339648]]
    


```python
#distance à l'origine - distance du KHI2
distoLig = numpy.sum(afc.row_coord_**2,axis=1)
print(distoLig)
```

    [0.17034955 0.00331062 0.0693019  0.03011317 0.2054925 ]
    


```python
#cos2 des lignes
cos2Lig = afc.row_coord_**2/numpy.reshape(distoLig,(5,1))*100
print(cos2Lig)
```

    [[9.87350266e+01 4.04596803e-01 8.60376599e-01]
     [1.22651866e+01 2.13488665e+01 6.63859469e+01]
     [9.95935831e+01 3.50970036e-01 5.54468168e-02]
     [6.70459405e+01 3.14556176e+01 1.49844193e+00]
     [9.91934675e+01 7.62676235e-01 4.38562850e-02]]
    


```python
#statistiques pour les points colonnes
print(afc.col_topandas())
```

              col_coord_dim1  col_coord_dim2  col_coord_dim3  col_contrib_dim1  \
    Droit           0.027987        0.060669       -0.016545          0.258518   
    Sciences        0.160462        0.002734        0.037583          7.944621   
    Medecine       -0.303125       -0.029662       -0.005200         41.583998   
    IUT             0.640174       -0.060749       -0.030870         50.212862   
    
              col_contrib_dim2  col_contrib_dim3  col_cos2_dim1  col_cos2_dim2  \
    Droit            58.758560         13.789476       0.165328       0.776896   
    Sciences          0.111572         66.520974       0.947735       0.000275   
    Medecine         19.259378          1.868040       0.990227       0.009482   
    IUT              21.870490         17.821510       0.988797       0.008904   
    
              col_cos2_dim3  
    Droit          0.057776  
    Sciences       0.051990  
    Medecine       0.000291  
    IUT            0.002299  
    


```python
#représentation simultanée
afc.mapping(num_x_axis=1,num_y_axis=2,figsize=(7,7))
```


![png](output_13_0.png)



```python
#point supplémentaire
bourgeois = numpy.array([638,537,1084,141])

#coordonnées factorielles
coordBourges = afc.transform(numpy.reshape(bourgeois,(1,4)))
print(coordBourges)
```

    [[-0.19494662 -0.0054899  -0.0065181 ]]
    


```python
#profil marginal des modalités colonnes
profMargCol = numpy.sum(D.values,axis=0)/n
print(profMargCol)
```

    [0.27193446 0.25422833 0.37288584 0.10095137]
    


```python
#profil des bourgeois
profBourges = bourgeois/numpy.sum(bourgeois)

#distance à l'origine de la modalité supplémentaire
distoBourges = numpy.sum(1/profMargCol*(profBourges-profMargCol)**2)
print(distoBourges)
```

    0.03807680914376361
    


```python
#COS2 de la représentation
cos2Bourges = (coordBourges**2)/distoBourges
print(cos2Bourges)
```

    [[9.98092681e-01 7.91530897e-04 1.11578809e-03]]
    


```python
#soit pour récapituler
print(pandas.DataFrame(numpy.transpose([coordBourges[0],cos2Bourges[0]]),index=['Dim.1','Dim.2','Dim.3'],columns=['Coord','Cos2']))
```

              Coord      Cos2
    Dim.1 -0.194947  0.998093
    Dim.2 -0.005490  0.000792
    Dim.3 -0.006518  0.001116
    


```python
#librairie graphique
import matplotlib.pyplot as plt

#reste à l'ajouter dans le plan factoriel
fig, ax = plt.subplots(figsize=(10,10))
ax.axis([-0.7,+0.7,-0.7,+0.7])
ax.plot([-0.7,+0.7],[0,0],color='silver',linestyle='--')
ax.plot([0,0],[-0.7,+0.7],color='silver',linestyle='--')
ax.set_xlabel("Dim.1")
ax.set_ylabel("Dim.2")
plt.title("Modalité ligne supplémentaire")

#modalités ligne
for i in range(D.shape[0]):
    ax.text(afc.row_coord_[i,0],afc.row_coord_[i,1],D.index[i],color='red')

#modalités colonne
for i in range(D.shape[1]):
    ax.text(afc.col_coord_[i,0],afc.col_coord_[i,1],D.columns[i],color='blue')
    
#point supplémentaire
ax.text(coordBourges[0][0],coordBourges[0][1],"Bourgeois",color='green')
    
plt.show()
```


![png](output_19_0.png)

