```python
#changement de dossier
import os
os.chdir("D:/_Travaux/university/Cours_Universite/Supports_de_cours/DataAnalysis/Stat/Supports/Analyse_Factorielle/Calculs")
```


```python
#chargement des données - index_col = 0 pour indiquer que la colonne n°0 est un label
import pandas
DataALL = pandas.read_excel("Data_Methodes_Factorielles.xlsx",sheet_name="AFDM_AUTOS",index_col=0)

#affichage des caractéristiques
print(DataALL.info())

#nombre d'observations
n = DataALL.shape[0]
```

    <class 'pandas.core.frame.DataFrame'>
    Index: 10 entries, GOLF         to SANTA_FE    
    Data columns (total 8 columns):
     #   Column     Non-Null Count  Dtype 
    ---  ------     --------------  ----- 
     0   puissance  10 non-null     int64 
     1   longueur   10 non-null     int64 
     2   hauteur    10 non-null     int64 
     3   poids      10 non-null     int64 
     4   CO2        10 non-null     int64 
     5   origine    10 non-null     object
     6   carburant  10 non-null     object
     7   4X4        10 non-null     object
    dtypes: int64(5), object(3)
    memory usage: 720.0+ bytes
    None
    


```python
#récupérer les variables quantitatives
DC = DataALL.iloc[:,:5]
print(DC)
```

                  puissance  longueur  hauteur  poids  CO2
    Modele                                                
    GOLF                 75       421      149   1217  143
    CITRONC4            138       426      146   1381  142
    P607                204       491      145   1723  223
    VELSATIS            150       486      158   1735  188
    CITRONC2             61       367      147    932  141
    CHRYS300            340       502      148   1835  291
    AUDIA3              102       421      143   1205  168
    OUTLAND             202       455      167   1595  237
    PTCRUISER           223       429      154   1595  235
    SANTA_FE            125       450      173   1757  197
    


```python
import numpy

#lesquelles sont centrées et réduites
ZC = (DC.values-numpy.mean(DC.values,axis=0))/numpy.std(DC.values,axis=0)
print(ZC)
```

    [[-1.1028751  -0.61403051 -0.41885391 -0.98856229 -1.12656547]
     [-0.30424141 -0.4850325  -0.73299434 -0.41057935 -1.14762277]
     [ 0.53242246  1.19194158 -0.83770782  0.79472655  0.55801841]
     [-0.1521207   1.06294357  0.52356739  0.83701799 -0.17898704]
     [-1.28034925 -2.00720898 -0.62828086 -1.99298388 -1.16868007]
     [ 2.2564571   1.47573719 -0.52356739  1.18944661  1.98991471]
     [-0.76060352 -0.61403051 -1.04713477 -1.03085373 -0.60013301]
     [ 0.50706901  0.26315593  1.46598868  0.34361791  0.85282059]
     [ 0.77328024 -0.4076337   0.10471348  0.34361791  0.81070599]
     [-0.46903884  0.13415793  2.09426954  0.91455228  0.01052865]]
    


```python
#récupérer les variables qualitatives
DD = DataALL.iloc[:,5:]
print(DD)
```

                 origine carburant  4X4
    Modele                             
    GOLF          Europe    Diesel  non
    CITRONC4      France    Diesel  non
    P607          France    Diesel  non
    VELSATIS      France    Diesel  non
    CITRONC2      France   Essence  non
    CHRYS300      Autres   Essence  non
    AUDIA3        Europe   Essence  non
    OUTLAND       Autres    Diesel  oui
    PTCRUISER     Autres   Essence  non
    SANTA_FE      Autres    Diesel  oui
    


```python
#codage 0/1
DDcoding = pandas.get_dummies(DD)
print(DDcoding)
```

                  origine_Autres  origine_Europe  origine_France  \
    Modele                                                         
    GOLF                       0               1               0   
    CITRONC4                   0               0               1   
    P607                       0               0               1   
    VELSATIS                   0               0               1   
    CITRONC2                   0               0               1   
    CHRYS300                   1               0               0   
    AUDIA3                     0               1               0   
    OUTLAND                    1               0               0   
    PTCRUISER                  1               0               0   
    SANTA_FE                   1               0               0   
    
                  carburant_Diesel  carburant_Essence  4X4_non  4X4_oui  
    Modele                                                               
    GOLF                         1                  0        1        0  
    CITRONC4                     1                  0        1        0  
    P607                         1                  0        1        0  
    VELSATIS                     1                  0        1        0  
    CITRONC2                     0                  1        1        0  
    CHRYS300                     0                  1        1        0  
    AUDIA3                       0                  1        1        0  
    OUTLAND                      1                  0        0        1  
    PTCRUISER                    0                  1        1        0  
    SANTA_FE                     1                  0        0        1  
    


```python
#proportions
p_k = numpy.mean(DDcoding.values,axis=0)
print(p_k)
```

    [0.4 0.2 0.4 0.6 0.4 0.8 0.2]
    


```python
#standardisation des indicatrices
ZD = DDcoding.values/numpy.sqrt(p_k)
print(ZD)
```

    [[0.         2.23606798 0.         1.29099445 0.         1.11803399
      0.        ]
     [0.         0.         1.58113883 1.29099445 0.         1.11803399
      0.        ]
     [0.         0.         1.58113883 1.29099445 0.         1.11803399
      0.        ]
     [0.         0.         1.58113883 1.29099445 0.         1.11803399
      0.        ]
     [0.         0.         1.58113883 0.         1.58113883 1.11803399
      0.        ]
     [1.58113883 0.         0.         0.         1.58113883 1.11803399
      0.        ]
     [0.         2.23606798 0.         0.         1.58113883 1.11803399
      0.        ]
     [1.58113883 0.         0.         1.29099445 0.         0.
      2.23606798]
     [1.58113883 0.         0.         0.         1.58113883 1.11803399
      0.        ]
     [1.58113883 0.         0.         1.29099445 0.         0.
      2.23606798]]
    


```python
#assembler les deux ensembles Z
Z = numpy.concatenate((ZC,ZD),axis=1)
print(Z)
```

    [[-1.1028751  -0.61403051 -0.41885391 -0.98856229 -1.12656547  0.
       2.23606798  0.          1.29099445  0.          1.11803399  0.        ]
     [-0.30424141 -0.4850325  -0.73299434 -0.41057935 -1.14762277  0.
       0.          1.58113883  1.29099445  0.          1.11803399  0.        ]
     [ 0.53242246  1.19194158 -0.83770782  0.79472655  0.55801841  0.
       0.          1.58113883  1.29099445  0.          1.11803399  0.        ]
     [-0.1521207   1.06294357  0.52356739  0.83701799 -0.17898704  0.
       0.          1.58113883  1.29099445  0.          1.11803399  0.        ]
     [-1.28034925 -2.00720898 -0.62828086 -1.99298388 -1.16868007  0.
       0.          1.58113883  0.          1.58113883  1.11803399  0.        ]
     [ 2.2564571   1.47573719 -0.52356739  1.18944661  1.98991471  1.58113883
       0.          0.          0.          1.58113883  1.11803399  0.        ]
     [-0.76060352 -0.61403051 -1.04713477 -1.03085373 -0.60013301  0.
       2.23606798  0.          0.          1.58113883  1.11803399  0.        ]
     [ 0.50706901  0.26315593  1.46598868  0.34361791  0.85282059  1.58113883
       0.          0.          1.29099445  0.          0.          2.23606798]
     [ 0.77328024 -0.4076337   0.10471348  0.34361791  0.81070599  1.58113883
       0.          0.          0.          1.58113883  1.11803399  0.        ]
     [-0.46903884  0.13415793  2.09426954  0.91455228  0.01052865  1.58113883
       0.          0.          1.29099445  0.          0.          2.23606798]]
    


```python
#classe de calcul
from fanalysis.pca import PCA

#instanciation - les données sont déjà standardisées
afdm = PCA(std_unit=False,row_labels=DataALL.index,col_labels=[DC.columns,DDcoding.columns])

#lancement des calculs
afdm.fit(Z)
```

    D:\Logiciels\Anaconda3\lib\site-packages\scipy\stats\stats.py:3538: PearsonRNearConstantInputWarning: An input array is nearly constant; the computed correlation coefficent may be inaccurate.
      warnings.warn(PearsonRNearConstantInputWarning())
    




    PCA(col_labels=[Index(['puissance', 'longueur', 'hauteur', 'poids', 'CO2'], dtype='object'),
                    Index(['origine_Autres', 'origine_Europe', 'origine_France',
           'carburant_Diesel', 'carburant_Essence', '4X4_non', '4X4_oui'],
          dtype='object')],
        n_components=None,
        row_labels=Index(['GOLF        ', 'CITRONC4    ', 'P607        ', 'VELSATIS    ',
           'CITRONC2    ', 'CHRYS300    ', 'AUDIA3      ', 'OUTLAND     ',
           'PTCRUISER   ', 'SANTA_FE    '],
          dtype='object', name='Modele'),
        stats=True, std_unit=False)




```python
#affichage des valeurs propres
print(afdm.eig_[0])
```

    [4.27313563e+00 2.12188732e+00 1.43871787e+00 8.36367144e-01
     1.64030083e-01 1.14470293e-01 3.36251524e-02 1.58052203e-02
     1.96128129e-03 1.08736851e-32]
    


```python
#projection des individus
afdm.mapping_row(1,2,figsize=(7,7))
```


![png](output_11_0.png)



```python
#coordonnées des individus sur le 1er facteur (F1)
print(afdm.row_coord_[:,0])
```

    [ 2.31780488  1.44536838 -0.77973114 -0.54106289  3.27586403 -2.95770457
      2.31613266 -2.25591897 -0.93180905 -1.88894333]
    


```python
#carré corrélations des variables quantitatives avec F1
corr2 = (numpy.corrcoef(afdm.row_coord_[:,0],DC.values,rowvar=False)**2)[0,1:]
print(corr2)
```

    [0.67132603 0.6339052  0.33451975 0.86400031 0.79327801]
    


```python
#data frame temporaire
temp = DD.copy()
temp['F1'] = afdm.row_coord_[:,0]

#carré du rapport de corrélation pour origine
eta_origine = numpy.sum((pandas.pivot_table(temp,values='F1',index='origine').values[:,0]**2)*p_k[:3])/afdm.eig_[0][0]
print(eta_origine)

#carré du rapport de corrélation pour carburant
eta_carburant = numpy.sum((pandas.pivot_table(temp,values='F1',index='carburant').values[:,0]**2)*p_k[3:5])/afdm.eig_[0][0]
print(eta_carburant)

#carré du rapport de corrélation pour 4X4
eta_4X4 = numpy.sum((pandas.pivot_table(temp,values='F1',index='4X4').values[:,0]**2)*p_k[5:])/afdm.eig_[0][0]
print(eta_4X4)
```

    0.6965665387607467
    0.028262312028001453
    0.2512774715903162
    


```python
#somme des carrés des corrélations et rapports de corrélation
sum_sq = numpy.sum(corr2) + eta_origine + eta_carburant + eta_4X4
print(sum_sq)

#première valeur propre de l'AFDM
print(afdm.eig_[0][0])
```

    4.273135626994877
    4.273135626994874
    


```python
#nombre maximal de facteurs
Hmax = 12-3

#librairie graphique
import matplotlib.pyplot as plt

#éboulis des v.p.
fix,ax = plt.subplots(figsize=(5,5))
ax.plot(range(1,Hmax+1),afdm.eig_[0][:Hmax],".-")
ax.set_xlabel("Nb. facteurs")
ax.set_ylabel("Val. propres")
plt.title("Eboulis des valeurs propres")

plt.show()
```


![png](output_16_0.png)



```python
#data frame temporaire
df = DD.copy()
df['F1'] = afdm.row_coord_[:,0]
df['F2'] = afdm.row_coord_[:,1]

#moyennes conditionnelles
pandas.pivot_table(df,values=['F1','F2'],index='origine')
```




<div>
<style scoped>
    .dataframe tbody tr th:only-of-type {
        vertical-align: middle;
    }

    .dataframe tbody tr th {
        vertical-align: top;
    }

    .dataframe thead th {
        text-align: right;
    }
</style>
<table border="1" class="dataframe">
  <thead>
    <tr style="text-align: right;">
      <th></th>
      <th>F1</th>
      <th>F2</th>
    </tr>
    <tr>
      <th>origine</th>
      <th></th>
      <th></th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <th>Autres</th>
      <td>-2.008594</td>
      <td>-0.217351</td>
    </tr>
    <tr>
      <th>Europe</th>
      <td>2.316969</td>
      <td>0.054035</td>
    </tr>
    <tr>
      <th>France</th>
      <td>0.850110</td>
      <td>0.190334</td>
    </tr>
  </tbody>
</table>
</div>




```python
#coordonnées des individus
print(pandas.DataFrame(afdm.row_coord_[:,:2],columns=['F1','F2'],index=DataALL.index))
```

                        F1        F2
    Modele                          
    GOLF          2.317805 -0.687271
    CITRONC4      1.445368 -0.122286
    P607         -0.779731  1.018563
    VELSATIS     -0.541063 -0.160059
    CITRONC2      3.275864  0.025117
    CHRYS300     -2.957705  2.628112
    AUDIA3        2.316133  0.795341
    OUTLAND      -2.255919 -1.840426
    PTCRUISER    -0.931809  1.090852
    SANTA_FE     -1.888943 -2.747943
    


```python
#coordonnées des variables-modalités
print(pandas.DataFrame(afdm.col_coord_[:,:2],columns=['F1','F2'],index=[list(DC.columns)+list(DDcoding.columns)]))
```

                             F1        F2
    puissance         -0.819345  0.539186
    longueur          -0.796182  0.244889
    hauteur           -0.578377 -0.763585
    poids             -0.929516  0.061131
    CO2               -0.890662  0.378984
    origine_Autres    -0.614538 -0.094369
    origine_Europe     0.501259  0.016589
    origine_France     0.260095  0.082639
    carburant_Diesel  -0.106325 -0.402313
    carburant_Essence  0.130221  0.492730
    4X4_non            0.224177  0.352170
    4X4_oui           -0.448355 -0.704340
    


```python
[list(DC.columns)+list(DDcoding.columns)]
```




    [['puissance',
      'longueur',
      'hauteur',
      'poids',
      'CO2',
      'origine_Autres',
      'origine_Europe',
      'origine_France',
      'carburant_Diesel',
      'carburant_Essence',
      '4X4_non',
      '4X4_oui']]


